/*
 * @(#)Synchronized3.java
 *
 * Copyright (C) 2003 Matt Albrecht
 * groboclown@users.sourceforge.net
 * http://groboutils.sourceforge.net
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.
 */

package net.sourceforge.groboutils.codecoverage.v2.compiler.testcode;



/**
 * Simple class to be recompiled.
 *
 * @author    Matt Albrecht <a href="mailto:groboclown@users.sourceforge.net">groboclown@users.sourceforge.net</a>
 * @version   $Date: 2003/05/03 02:54:27 $
 * @since     May 2, 2003
 */
public class Synchronized3 implements Runnable
{
    int j = 0;
    public static void main( String[] args ) throws Exception
    {
        Synchronized3 s2 = new Synchronized3();
        Thread t1 = new Thread( s2 );
        Thread t2 = new Thread( s2 );
        t1.start();
        t2.start();
        
        t1.join();
        t2.join();
        if (s2.j == 6)
        {
            Passed.passed( "Synchronized3" );
        }
    }
    
    
    public void run()
    {
        for (int i = 0; i < 10; ++i)
        {
            synchronized( this )
            {
                if (i == 3)
                {
                    throw new RuntimeException();
                }
                ++j;
            }
            try
            {
                Thread.sleep( 100 );
            }
            catch (InterruptedException ie)
            {
                return;
            }
        }
    }
    
}

